﻿Type=Service
Version=1.60
StartAtBoot=False
@EndOfDesignText@
'Service module
Sub Process_Globals
	Dim rv As RemoteViews
End Sub
Sub Service_Create
	'Set the widget to update every 60 minutes.
	rv = ConfigureHomeWidget("L1", "rv", 60, "Hello Widget 4x2")
End Sub

Sub Service_Start (StartingIntent As Intent)
	rv.HandleWidgetEvents(StartingIntent)
End Sub

Sub rv_RequestUpdate

	Dim rs As RichString
	Dim rsf As RichStringFormatter
	Dim vText As String
		
	rsf.Initialize("<sample>")
	rsf.AddToken("<red>", rsf.FORMAT_COLOR, Colors.RGB(250, 128, 114))
	rsf.AddToken("<blue>", rsf.FORMAT_COLOR, Colors.RGB(176, 224, 230))

	vText = "<red>27°<red>/<blue>13°<blue>"
	rs.Initialize(vText)

	Dim Obj1 As Reflector
	Dim args(2) As Object
	Dim types(2) As String
	Obj1.Target = rv ' a RemoteViewsWrapper
	
	' first we need the Id of the view
	args(0) = Obj1.GetProcessBA("WidgetService")
	types(0) = "anywheresoftware.b4a.BA"
	args(1) = "Label1"
	types(1) = "java.lang.String"
	args(0) = Obj1.RunMethod4("getIdForView", args, types) ' get the view Id
	types(0) = "java.lang.int"
	' now the RichText charSequence
	args(1) = rsf.Format(rs, rsf.SPAN_INCLUSIVE_EXCLUSIVE) ' CharSequence
	types(1) = "java.lang.CharSequence"	
	' now do the dirty work
	Obj1.RunMethod("checkNull") 'does some internal checking and may set current
	Obj1.Target = Obj1.GetField("current") ' a RemoteViews - get this after checkNull
	Obj1.RunMethod4("setTextViewText", args, types)	
	' Voila!	
	rv.UpdateWidget
	
End Sub

Sub rv_Disabled
	StopService("")
End Sub

Sub Service_Destroy

End Sub


Sub SetRichtext(textview As String, richtext As String)


End Sub


Sub Panel1_Click
	rv_RequestUpdate
End Sub


